# sys.auto(tick)
# 系統 自動更新

# Q25
execute as @a if entity @s[x=-2,y=19,z=-2,dx=4,dy=40,dz=4] run effect give @s minecraft:slow_falling 30 0 true
execute as @a unless entity @s[x=-2,y=19,z=-2,dx=4,dy=40,dz=4] run effect clear @s slow_falling
execute as @a[x=-2,y=19,z=-2,dx=4,dy=40,dz=4] at @s if entity @s[nbt={OnGround:1b}] if block ~ ~-1 ~ bone_block[axis=y] run tp @s ~ ~-4 ~

execute if block 2 16 0 stone_button[powered=true] run tp @a 0 54 0
execute if block -2 16 0 stone_button[powered=true] run tp @a 0 54 0

execute if block 2 16 0 stone_button[powered=true] run scoreboard players add retry system 1
execute if block -2 16 0 stone_button[powered=true] run scoreboard players add retry system 1
execute if score retry system matches ..2 if block 2 16 0 stone_button[powered=true] run setblock 2 16 0 stone_button[powered=false,face=ceiling,facing=east]
execute if score retry system matches ..2 if block -2 16 0 stone_button[powered=true] run setblock -2 16 0 stone_button[powered=false,face=ceiling,facing=west]
execute if score retry system matches 3.. if block 2 16 0 stone_button run setblock 2 16 0 air destroy
execute if score retry system matches 3.. if block -2 16 0 stone_button run setblock -2 16 0 air destroy

execute if block 3 12 -1 stone_pressure_plate[powered=true] run tag @a[tag=!final,x=3,y=12,z=-1,distance=..2] add false
execute if block 3 12 1 stone_pressure_plate[powered=true] run tag @a[tag=!final,x=3,y=12,z=1,distance=..2] add false
execute if block 1 12 3 stone_pressure_plate[powered=true] run tag @a[tag=!false,x=1,y=12,z=3,distance=..2] add final
execute if block -1 12 3 stone_pressure_plate[powered=true] run tag @a[tag=!final,x=-1,y=12,z=3,distance=..2] add false
execute if block -3 12 1 stone_pressure_plate[powered=true] run tag @a[tag=!final,x=-3,y=12,z=1,distance=..2] add false
execute if block -3 12 -1 stone_pressure_plate[powered=true] run tag @a[tag=!final,x=-3,y=12,z=-1,distance=..2] add false
execute if block -1 12 -3 stone_pressure_plate[powered=true] run tag @a[tag=!final,x=-1,y=12,z=-3,distance=..2] add false
execute if block 1 12 -3 stone_pressure_plate[powered=true] run tag @a[tag=!final,x=1,y=12,z=-3,distance=..2] add false

execute as @a[tag=false] run function game:final/false
execute as @a[tag=final] run function game:final/true

execute as @a[scores={system=100}] run scoreboard players reset @s system

# Q13 ~ Q24
replaceitem block 0 41 -5 container.10 potion{Potion:"invisibility",HideFlags:32,x:8,y:7}
replaceitem block 0 41 -5 container.12 potion{Potion:"water_breathing",HideFlags:32,x:8,y:7}
replaceitem block 0 41 -5 container.14 potion{Potion:"thick",display:{Name:"{\"translate\":\"item.minecraft.potion.effect.thick\",\"color\":\"white\",\"italic\":false}"},Enchantments:[{}],HideFlags:32}
replaceitem block 0 41 -5 container.16 potion{Potion:"weakness",HideFlags:32,x:8,y:7}

execute as @e[type=item_frame,tag=ans,nbt=!{Item:{Count:1b}},nbt={Invulnerable:0b}] run data merge entity @s {Invulnerable:1b}
execute as @e[type=item_frame,tag=ans,nbt={Item:{Count:1b}},nbt={Invulnerable:1b}] run data merge entity @s {Invulnerable:0b}

execute if block 0 34 -5 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add 13
execute if block 5 36 0 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add 14
execute if block 0 38 5 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add 15
execute if block -5 40 0 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add 16
execute if block 0 42 -5 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add 17
execute if block 5 44 0 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add 18
execute if block 0 46 5 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add 19
execute if block -5 48 0 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add 20
execute if block 0 50 -5 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add 21
execute if block 5 52 0 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add 22
execute if block 0 54 5 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add 23
execute if block -5 56 0 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add 24

execute if block 0 34 -5 stone_button[powered=true] as @a if entity @s[tag=13] unless entity @s[tag=confirm] run function game:check
execute if block 5 36 0 stone_button[powered=true] as @a if entity @s[tag=14] unless entity @s[tag=confirm] run function game:check
execute if block 0 38 5 stone_button[powered=true] as @a if entity @s[tag=15] unless entity @s[tag=confirm] run function game:check
execute if block -5 40 0 stone_button[powered=true] as @a if entity @s[tag=16] unless entity @s[tag=confirm] run function game:check
execute if block 0 42 -5 stone_button[powered=true] as @a if entity @s[tag=17] unless entity @s[tag=confirm] run function game:check
execute if block 5 44 0 stone_button[powered=true] as @a if entity @s[tag=18] unless entity @s[tag=confirm] run function game:check
execute if block 0 46 5 stone_button[powered=true] as @a if entity @s[tag=19] unless entity @s[tag=confirm] run function game:check
execute if block -5 48 0 stone_button[powered=true] as @a if entity @s[tag=20] unless entity @s[tag=confirm] run function game:check
execute if block 0 50 -5 stone_button[powered=true] as @a if entity @s[tag=21] unless entity @s[tag=confirm] run function game:check
execute if block 5 52 0 stone_button[powered=true] as @a if entity @s[tag=22] unless entity @s[tag=confirm] run function game:check
execute if block 0 54 5 stone_button[powered=true] as @a if entity @s[tag=23] unless entity @s[tag=confirm] run function game:check
execute if block -5 56 0 stone_button[powered=true] as @a if entity @s[tag=24] unless entity @s[tag=confirm] run function game:check

execute if block 0 34 -5 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add confirm
execute if block 5 36 0 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add confirm
execute if block 0 38 5 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add confirm
execute if block -5 40 0 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add confirm
execute if block 0 42 -5 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add confirm
execute if block 5 44 0 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add confirm
execute if block 0 46 5 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add confirm
execute if block -5 48 0 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add confirm
execute if block 0 50 -5 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add confirm
execute if block 5 52 0 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add confirm
execute if block 0 54 5 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add confirm
execute if block -5 56 0 stone_button[powered=true] unless entity @a[tag=confirm] run tag @r add confirm

execute if block 0 34 -5 stone_button[powered=true] run setblock 0 34 -5 stone_button[facing=north,powered=false]
execute if block 5 36 0 stone_button[powered=true] run setblock 5 36 0 stone_button[facing=east,powered=false]
execute if block 0 38 5 stone_button[powered=true] run setblock 0 38 5 stone_button[facing=south,powered=false]
execute if block -5 40 0 stone_button[powered=true] run setblock -5 40 0 stone_button[facing=west,powered=false]
execute if block 0 42 -5 stone_button[powered=true] run setblock 0 42 -5 stone_button[facing=north,powered=false]
execute if block 5 44 0 stone_button[powered=true] run setblock 5 44 0 stone_button[facing=east,powered=false]
execute if block 0 46 5 stone_button[powered=true] run setblock 0 46 5 stone_button[facing=south,powered=false]
execute if block -5 48 0 stone_button[powered=true] run setblock -5 48 0 stone_button[facing=west,powered=false]
execute if block 0 50 -5 stone_button[powered=true] run setblock 0 50 -5 stone_button[facing=north,powered=false]
execute if block 5 52 0 stone_button[powered=true] run setblock 5 52 0 stone_button[facing=east,powered=false]
execute if block 0 54 5 stone_button[powered=true] run setblock 0 54 5 stone_button[facing=south,powered=false]
execute if block -5 56 0 stone_button[powered=true] run setblock -5 56 0 stone_button[facing=west,powered=false]

execute if block 0 34 -5 stone_button[powered=false] if entity @a[tag=confirm] run tag @a[tag=confirm] remove confirm
execute if block 5 36 0 stone_button[powered=false] if entity @a[tag=confirm] run tag @a[tag=confirm] remove confirm
execute if block 0 38 5 stone_button[powered=false] if entity @a[tag=confirm] run tag @a[tag=confirm] remove confirm
execute if block -5 40 0 stone_button[powered=false] if entity @a[tag=confirm] run tag @a[tag=confirm] remove confirm
execute if block 0 42 -5 stone_button[powered=false] if entity @a[tag=confirm] run tag @a[tag=confirm] remove confirm
execute if block 5 44 0 stone_button[powered=false] if entity @a[tag=confirm] run tag @a[tag=confirm] remove confirm
execute if block 0 46 5 stone_button[powered=false] if entity @a[tag=confirm] run tag @a[tag=confirm] remove confirm
execute if block -5 48 0 stone_button[powered=false] if entity @a[tag=confirm] run tag @a[tag=confirm] remove confirm
execute if block 0 50 -5 stone_button[powered=false] if entity @a[tag=confirm] run tag @a[tag=confirm] remove confirm
execute if block 5 52 0 stone_button[powered=false] if entity @a[tag=confirm] run tag @a[tag=confirm] remove confirm
execute if block 0 54 5 stone_button[powered=false] if entity @a[tag=confirm] run tag @a[tag=confirm] remove confirm
execute if block -5 56 0 stone_button[powered=false] if entity @a[tag=confirm] run tag @a[tag=confirm] remove confirm

# hints
execute as @a at @s as @e[type=armor_stand,tag=ans,nbt=!{CustomNameVisible:1b},distance=..4] run data merge entity @s {CustomNameVisible:1b}
execute as @a at @s as @e[type=armor_stand,tag=ans,nbt={CustomNameVisible:1b},distance=4..] run data merge entity @s {CustomNameVisible:0b}
execute as @e[type=armor_stand,tag=ans] at @s run clear @a[distance=..4]